<?php

// WARNING: When saving this file, make sure your text/code editor does NOT insert a
// byte order mark (BOM)!!!
// (This would be the UTF-8 BOM: The 3 bytes EF BB BF at the beginning of the file)
// To remove a BOM, you can use an editor in ASCII editing mode.


// Zanox Engine function provider and compatibility supplement for older PHP versions:

// Defines deBOM(), u8h(), strcasecmp_uh(), fmtDate(), fmtTime(), and deCDATA(),
// which are required by the scripts.
// Defines file_get_contents() if necessary, required for PHP ver. <4.3.0
// Defines file_put_contents() if necessary, required for PHP ver. <5
// Loads the PHP code from srv_json.php if necessary, required for PHP ver. <5.2.0
// Defines json_encode() if necessary, required for PHP ver. <5.2.0
// Defines json_decode() if necessary, required for PHP ver. <5.2.0



// Defines a function that strips a UTF-8 BOM:

function deBOM($d)
   {
    if (substr($d, 0, 3) == pack('CCC', 239, 187, 191))
       {
        return substr($d, 3);
       }
    else
       {
        return $d;
       }
   }



// Defines a function that converts the most important UTF-8 multibyte characters to HTML entities;
// here, the UTF-8 multibyte sequences are inserted directly instead of using pack():

function u8h($s)
   {
    $spc = array('à','á','â','ç','è','é','ê','ë','í','ñ',
    'ò','ó','ô','ù','ú','č','Č','°','±','«',
    '»','œ','Œ','¿','²','³','‘','’','“','”',
    '‚','„','‰','‹','›','¼','½','¾','À','Á',
    'Â','È','É','Ê','Ë','Í','î','Î','Ò','Ó',
    'Ô','û','Û','æ','Æ','¡','ª','µ','Δ','α',
    'β','γ','Ω','‐','–','—','№','→','º','≠',
    '≤','≥','†','•','⁃','™','∘','ä','ö','ü',
    'Ä','Ö','Ü','ß','€','£','¢','¥','©','®',
    '¬','⋄','♦','×','Ù','Ú','ã','Ã','õ','ï',
    'Ï','¤','…','′','″','‡',' ',' ',' ','◊',
    'Σ','π','š','Š','ž','Ž','ƒ','ø','Ø','å',
    'Å','ł','Ł','ř','Ř','ő','Ő','ű','Ű','▪',
    'ą','Ą','ę','Ę','ć','Ć','ń','Ń','ś','Ś',
    'ź','Ź','ż','Ż','ď','Ď','ě','Ě','ň','Ň',
    'ť','Ť','ů','Ů','ý','Ý','ÿ','Ÿ','ğ','Ğ',
    'ı','İ','ş','Ş','ă','Ă','ș','Ș','ţ','Ţ',
    'ț','Ț','ĳ','Ĳ','Õ','ì','Ì','ð','Ð','þ',
    'Þ','ε','Γ','○','∅','Ç',' ','','·','÷',
    '','','','§','','―','´','','','',
    '','°','','','','','','­','²','£',
    '«','»','','','¹','Đ','đ');
    $equ = array('&agrave;','&aacute;','&acirc;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&iacute;','&ntilde;',
    '&ograve;','&oacute;','&ocirc;','&ugrave;','&uacute;','&ccaron;','&Ccaron;','&deg;','&plusmn;','&laquo;',
    '&raquo;','&oelig;','&OElig;','&iquest;','&sup2;','&sup3;','&lsquo;','&rsquo;','&ldquo;','&rdquo;',
    '&sbquo;','&bdquo;','&permil;','&lsaquo;','&rsaquo;','&frac14;','&frac12;','&frac34;','&Agrave;','&Aacute;',
    '&Acirc;','&Egrave;','&Eacute;','&Ecirc;','&Euml;','&Iacute;','&icirc;','&Icirc;','&Ograve;','&Oacute;',
    '&Ocirc;','&ucirc;','&Ucirc;','&aelig;','&AElig;','&iexcl;','&ordf;','&micro;','&Delta;','&alpha;',
    '&beta;','&gamma;','&Omega;','&hyphen;','&ndash;','&mdash;','&numero;','&rarr;','&ordm;','&ne;',
    '&le;','&ge;','&dagger;','&bull;','&hybull;','&trade;','&compfn;','&auml;','&ouml;','&uuml;',
    '&Auml;','&Ouml;','&Uuml;','&szlig;','&euro;','&pound;','&cent;','&yen;','&copy;','&reg;',
    '&not;','&diam;','&diams;','&times;','&Ugrave;','&Uacute;','&atilde;','&Atilde;','&otilde;','&iuml;',
    '&Iuml;','&curren;','&hellip;','&prime;','&Prime;','&Dagger;','&ensp;','&emsp;','&thinsp;','&loz;',
    '&Sigma;','&pi;','&scaron;','&Scaron;','&zcaron;','&Zcaron;','&fnof;','&oslash;','&Oslash;','&aring;',
    '&Aring;','&lstrok;','&Lstrok;','&rcaron;','&Rcaron;','&odblac;','&Odblac;','&udblac;','&Udblac;','&squf;',
    '&aogon;','&Aogon;','&eogon;','&Eogon;','&cacute;','&Cacute;','&nacute;','&Nacute;','&sacute;','&Sacute;',
    '&zacute;','&Zacute;','&zdot;','&Zdot;','&dcaron;','&Dcaron;','&ecaron;','&Ecaron;','&ncaron;','&Ncaron;',
    '&tcaron;','&Tcaron;','&uring;','&Uring;','&yacute;','&Yacute;','&yuml;','&Yuml;','&gbreve;','&Gbreve;',
    '&imath;','&Idot;','&scedil;','&Scedil;','&abreve;','&Abreve;','&#537;','&#536;','&tcedil;','&Tcedil;',
    '&#539;','&#538;','&ijlig;','&IJlig;','&Otilde;','&igrave;','&Igrave;','&eth;','&ETH;','&thorn;',
    '&THORN;','&epsiv;','&Gamma;','&cir;','&empty;','&Ccedil;','&nbsp;','&euro;','&middot;','&divide;',
    '&ndash;','&bdquo;','&ldquo;','&sect;','&trade;','&horbar;','&acute;','&rsquo;','&rdquo;','&bull;',
    '&lsquo;','&deg;','&hellip;','&scaron;','&zcaron;','&Scaron;','&Zcaron;','&shy;','&sup2;','&pound;',
    '&laquo;','&raquo;','&sbquo;','&mdash;','&sup1;','&Dstrok;','&dstrok;');
    return str_replace($spc, $equ, $s);
   }



// Defines replacement for strcasecmp() which also handles HTML entities of some diacritics correctly:

function strcasecmp_uh($s1, $s2)
   {
    $uml = array('&agrave;','&aacute;','&acirc;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&iacute;','&ntilde;',
    '&ograve;','&oacute;','&ocirc;','&ugrave;','&uacute;','&ccaron;','&Ccaron;','&oelig;','&OElig;','&Agrave;',
    '&Aacute;','&Acirc;','&Egrave;','&Eacute;','&Ecirc;','&Euml;','&Iacute;','&icirc;','&Icirc;','&Ograve;',
    '&Oacute;','&Ocirc;','&ucirc;','&Ucirc;','&aelig;','&AElig;','&auml;','&ouml;','&uuml;','&Auml;',
    '&Ouml;','&Uuml;','&szlig;','&Ugrave;','&Uacute;','&atilde;','&Atilde;','&otilde;','&iuml;','&Iuml;',
    '&scaron;','&Scaron;','&zcaron;','&Zcaron;','&oslash;','&Oslash;','&aring;','&Aring;','&lstrok;','&Lstrok;',
    '&rcaron;','&Rcaron;','&odblac;','&Odblac;','&udblac;','&Udblac;','&aogon;','&Aogon;','&eogon;','&Eogon;',
    '&cacute;','&Cacute;','&nacute;','&Nacute;','&sacute;','&Sacute;','&zacute;','&Zacute;','&zdot;','&Zdot;',
    '&dcaron;','&Dcaron;','&ecaron;','&Ecaron;','&ncaron;','&Ncaron;','&tcaron;','&Tcaron;','&uring;','&Uring;',
    '&yacute;','&Yacute;','&yuml;','&Yuml;','&gbreve;','&Gbreve;','&imath;','&Idot;','&scedil;','&Scedil;',
    '&abreve;','&Abreve;','&#x0219;','&#x0218;','&tcedil;','&Tcedil;','&#x021b;','&#x021a;','&ijlig;','&IJlig;',
    '&Otilde;','&igrave;','&Igrave;','&eth;','&ETH;','&thorn;','&THORN;','&Ccedil;','&#537;','&#536;',
    '&#539;','&#538;','&Dstrok;','&dstrok;');
    $equ = array('a','a','a','c','e','e','e','e','i','n',
    'o','o','o','u','u','c','C','oe','OE','A',
    'A','A','E','E','E','E','I','i','I','O',
    'O','O','u','U','ae','AE','ae','oe','ue','Ae',
    'Oe','Ue','ss','U','U','a','A','o','i','I',
    's','S','z','Z','oe','Oe','a','A','l','L',
    'r','R','oe','Oe','ue','Ue','a','A','e','E',
    'c','C','n','N','s','S','z','Z','z','Z',
    'd','D','e','E','n','N','t','T','u','U',
    'y','Y','y','Y','g','G','i','I','s','S',
    'a','A','s','S','t','T','t','T','ij','Ij',
    'O','i','I','d','D','th','Th','C','s','S',
    't','T','D','d');
    return strcasecmp(str_replace($uml, $equ, $s1), str_replace($uml, $equ, $s2));
   }



// ISO 8601 full date/time representations are not supported in PHP 4, therefore:

function fmtDate($dt, $c='EN')
   {
    if ($c=='DE')
       {
        return substr($dt, 8, 2).'.'.substr($dt, 5, 2).'.'.substr($dt, 0, 4);
       }
    else
       {
        return substr($dt, 5, 2).'/'.substr($dt, 8, 2).'/'.substr($dt, 0, 4);
       }
   }

function fmtTime($dt, $c='EN')
   {
    if ($c=='DE')
       {
        return substr($dt, 11, 8).' ('.substr($dt, 19, 6).')';
       }
    else
       {
        $h = intval(substr($dt, 11, 2));
        $m = intval(substr($dt, 14, 2));
        $v = $h*100 + $m;
        if ($v == 0)
           { $h = 12; $n = 'midn'; }
        elseif ($v > 0 && $v <= 59)
           { $h = 12; $n = 'AM  '; }
        elseif ($v >= 100 && $v <= 1159)
           { $n = 'AM  '; }
        elseif ($v == 1200)
           { $n = 'noon'; }
        elseif ($v > 1200 && $v <= 1259)
           { $n = 'PM  '; }
        else
           { $h -= 12; $n = 'PM  '; }
        return sprintf("% 2u:%02u:", $h, $m).substr($dt, 17, 2).' '.$n.' ('.substr($dt, 19, 6).')';
       }
   }



// Defines a function that strips CDATA tags:

function deCDATA($s)
   {
    $s = str_replace('<![CDATA[', '', $s);
    $s = str_replace(']]>', '', $s);
    return $s;
   }



// Defines file_get_contents() if necessary, required for PHP ver. <4.3.0:

if (!function_exists('file_get_contents'))
   {
    function file_get_contents($filename)
       {
        $f = @fopen($filename, 'rb');
        if (!$f)
           {
            return false;
           }
        else
           {
            $bytes = fread($f, 40000000);
            fclose($f);
            return $bytes;
           }
       }
   }


// Defines file_put_contents() if necessary, required for PHP ver. <5:

if (!function_exists('file_put_contents'))
   {
    function file_put_contents($filename, $data)
       {
        $f = @fopen($filename, 'wb');
        if (!$f)
           {
            return false;
           }
        else
           {
            $bytes = fwrite($f, $data);
            fclose($f);
            return $bytes;
           }
       }
   }



// If necessary, this will load the entire PHP code of the "Services_JSON" PEAR package,
// published by Michal Migurski in 2005 under BSD license,
// used here for the definitions of json_encode() and json_decode()
// using Services_JSON::encode() and Services_JSON::decode():
if (!function_exists('json_encode') || !function_exists('json_decode'))
   {
    include 'srv_json.php';
   }


// Defines json_encode() if necessary, required for PHP ver. <5.2.0:
if (!function_exists('json_encode'))
   {
    function json_encode($data)
       {
        $json = new Services_JSON();
        return($json->encode($data));
       }
   }

// Defines json_decode() if necessary, required for PHP ver. <5.2.0:
if (!function_exists('json_decode'))
   {
    function json_decode($data, $f=true)
       {
        if ($f==true) {$f = SERVICES_JSON_LOOSE_TYPE;} else {$f = NULL;}
        $json = new Services_JSON($f);
        return($json->decode($data));
       }
   }

?>
