<?php

// Downloads all programs' data records and saves them in programs.json
// Downloads all coupon incentives' data records and saves them in incentives.json

// This file is executed automatically by ZanoxEngine_init.php.


// Download all programs' data records in portions of a max. no. of 49 items each and
// assemble in valid JSON structure into programs.json
// (When using a max. no. of 50 items each, a wrong value of 'total' may be sent!)

$req = "http://api.zanox.com/json/2011-03-01/programs?region=".$Region."&connectid=".$ConnectID."&page=0&items=1";
$data = file_get_contents($req);
$array = json_decode(deBOM($data), true);

$total = $array['total'];

$pages = ceil($total/49)-1; // No. of the last page; the first page has no. 0

$f = fopen('programs.json', 'wb');

fwrite($f, "{\"page\":0,\"items\":".$total.",\"total\":".$total.",\"programItems\":{\"programItem\":[");

for ($i = 0; $i <= $pages; $i++)
   {
    $req = "http://api.zanox.com/json/2011-03-01/programs?region=".$Region."&connectid=".$ConnectID."&items=49&page=".$i;
    $data = file_get_contents($req);
    $stest = substr($data, 0, 30);
    if (strpos($stest, "\"items\":0,") !== false)   // The page already doesn't contain further data -> break
       {
        print("* Unexpected end of transmission *<br>\r\n");
        break;
       }
    if ($i>0) fwrite($f, ',');
    $p = strpos($data, "\"programItem\":[");
    $data = substr($data, $p+15, -3);
    fwrite($f, $data);
    print("downloaded programs page no. ".($i+1)." of ".($pages+1)."<br>\r\n");
   }

fwrite($f, "]}}");

fclose($f);

print("<br>\r\n");

// Download all coupon incentives' data records in portions of a max. no. of 49 items each and
// assemble in valid JSON structure into incentives.json
// (When using a max. no. of 50 items each, a wrong value of 'total' may be sent!)

$req = "http://api.zanox.com/json/2011-03-01/incentives?region=".$Region."&connectid=".$ConnectID."&incentiveType=coupons&page=0&items=1";
$data = file_get_contents($req);
$array = json_decode(deBOM($data), true);

$total = $array['total'];

$pages = ceil($total/49)-1; // No. of the last page; the first page has no. 0

$f = fopen('incentives.json', 'wb');

fwrite($f, "{\"page\":0,\"items\":".$total.",\"total\":".$total.",\"incentiveItems\":{\"incentiveItem\":[");

for ($i = 0; $i <= $pages; $i++)
   {
    $req = "http://api.zanox.com/json/2011-03-01/incentives?region=".$Region."&connectid=".$ConnectID."&incentiveType=coupons&items=49&page=".$i;
    $data = file_get_contents($req);
    $stest = substr($data, 0, 30);
    if (strpos($stest, "\"items\":0,") !== false)   // The page already doesn't contain further data -> break
       {
        print("* Unexpected end of transmission *<br>\r\n");
        break;
       }
    if ($i>0) fwrite($f, ',');
    $p = strpos($data, "\"incentiveItem\":");
    $d=0; if (substr($data, $p+16, 1)=='[') $d=1;
    $data = substr($data, $p+16+$d, -2-$d);
    fwrite($f, $data);
    print("downloaded incentives page no. ".($i+1)." of ".($pages+1)."<br>\r\n");
   }

fwrite($f, "]}}");

fclose($f);

print("<br>- Downloading finished! -<br>\r\n");

?>
